/*******************************************************************************
 * Copyright (c) 2008 Marian Schedenig
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marian Schedenig - initial API and implementation
 *******************************************************************************/ 

package com.musgit.eclipse.grepconsole.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.console.IConsoleView;

import com.musgit.eclipse.grepconsole.Activator;
import com.musgit.eclipse.grepconsole.manageexpressions.ManageExpressionsDialog;

/**
 * Opens the Grep Expression management dialog.
 *  
 * @author msched
 */
public class ManageExpressionsAction implements IViewActionDelegate
{
	/** The console view for which this delegate was instantiated. */
	@SuppressWarnings("unused")
	private IConsoleView consoleView;
	
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.IViewActionDelegate#init(org.eclipse.ui.IViewPart)
	 */
//	@Override
	public void init(IViewPart view)
	{
		consoleView = (IConsoleView)view;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 */
//	@Override
	public void selectionChanged(IAction action, ISelection selection)
	{
	}

	/**
	 * Opens the settings dialog.
	 * 
	 * TODO: When we support multiple persistent configurations, this should
	 * access the current console to determine which setting is to be edited.
	 * 
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 */
//	@Override
	public void run(IAction action)
	{
		/*
		 * The following gives us the current console:
		 * System.out.println("Current console: " + consoleView.getConsole());
		 *
		 * And this gives us the current console page, which contains the console
		 * viewer to which our background listener is added:
		 * System.out.println("Current page: " + ((PageBookView)consoleView).getCurrentPage()); 
		 */
		 
		Activator plugin = Activator.getDefault();
		IWorkbench workbench = plugin.getWorkbench();
		Shell shell = workbench.getActiveWorkbenchWindow().getShell();
		ManageExpressionsDialog dlg = new ManageExpressionsDialog(shell);
		dlg.open();
		plugin.saveSettings();
	}
}
