/*******************************************************************************
 * Copyright (c) 2008 Marian Schedenig
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marian Schedenig - initial API and implementation
 *******************************************************************************/ 

package com.musgit.eclipse.grepconsole.manageexpressions;

import java.util.List;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.musgit.eclipse.grepconsole.model.GrepConsoleSettings;
import com.musgit.eclipse.grepconsole.model.GrepExpression;

/**
 * A content provider for grep expressions.
 * 
 * @author msched
 */
public class ExpressionsContentProvider implements IStructuredContentProvider
{
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
//	@Override
	public void dispose()
	{
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
//	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
	{
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
	 */
	@SuppressWarnings("unchecked")
//	@Override
	public Object[] getElements(Object inputElement)
	{
		if(inputElement instanceof GrepConsoleSettings)
		{
			inputElement = ((GrepConsoleSettings)inputElement).getExpressions();
		}
		
		List<GrepExpression> expressions = (List<GrepExpression>)inputElement;
		return expressions.toArray();
	}
}
